unit Unit1; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  Grids, StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
     Button1: TButton;
     StringGrid1: TStringGrid;
     procedure Button1Click(Sender: TObject);
     procedure FormCreate(Sender: TObject);
     procedure StringGrid1DblClick(Sender: TObject);
     procedure StringGrid1PrepareCanvas(sender: TObject; aCol, aRow: Integer;
        aState: TGridDrawState);
     procedure StringGrid1Resize(Sender: TObject);
     procedure ResizeGrid(grid: TStringGrid);
     procedure Add(s: String);
  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  Form1: TForm1; 

implementation

uses
   strutils, math;

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
   StringGrid1.Options:=StringGrid1.Options-[goDrawFocusSelected];
   StringGrid1.FocusRectVisible:=false;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
   Add('LOREM IPSUM LOREM IPSUM LOREM IPSUM LOREM IPSUM LOREM IPSUM LOREM IPSUM LOREM IPSUM LOREM IPSUM LOREM IPSUM LOREM IPSUM LOREM IPSUML OREM IPSUMLOR EM IPSUM');
end;

procedure TForm1.StringGrid1DblClick(Sender: TObject);
begin

end;

procedure TForm1.StringGrid1PrepareCanvas(sender: TObject; aCol, aRow: Integer;
  aState: TGridDrawState);
var
  x: TTextStyle;
begin
  x := StringGrid1.DefaultTextStyle;
  x.SingleLine:=false;
  x.Wordbreak:=true;
  x.Layout:=tlTop;
  Stringgrid1.Canvas.TextStyle := x;
end;

procedure TForm1.StringGrid1Resize(Sender: TObject);
begin
   ResizeGrid(Sender as TStringGrid);
end;

procedure TForm1.ResizeGrid(grid: TStringGrid);
var
   i, j, w, h, realWidth : Integer;
begin
   w := 0;
   h := 0;
   with grid do
   for i := 0 to RowCount-1 do
   begin
      Canvas.GetTextSize(Cells[0,i], w,h);
      w := w + 12;

      realWidth:=ColWidths[0];

      WriteLn('w ',w,' Width ',realWidth,' h ',h);

      RowHeights[i] := 3 + trunc(ceil(w
        / realWidth) *( 2+ h));
   end;
end;

procedure TForm1.Add(s: String);
begin
   StringGrid1.RowCount:=StringGrid1.RowCount+1;
   StringGrid1.Cells[0,StringGrid1.RowCount-1] := s;

   ResizeGrid(StringGrid1);
end;

initialization
  {$I unit1.lrs}

end.

